# .gitlab-ci.yml File for running job(s) based on commits to specific feature branches matching pattern 
#
# Matches must start with the matching string (JIRA project key) followed by hyphenated digits (JIRA project id).
#
# Example positive matches,
#   - "F-1-some-new-feature"
#   - "BAR-1234-some-new-feature"
#   - "QUUX-123456-some-new-feature"
#
# The following defaults are pretty common and arbitrarily set to show examples of forcing lengths.  
# You can adjust shorter/longer in the regex down below.
#
#   * 6 character JIRA key
#   * 6 character JIRA project ID
#
# HOWTO
#
# 1. Update the variable $MY_JIRA_KEY with your JIRA project key.  Assume defaults above work.
# 2. Provide JIRA API Token and Server URL
# 3. Update job 'custom-jira-job' with your custom API call (JIRA API Reference docs: https://developer.atlassian.com/cloud/jira/platform/rest/v3/)
#
# Supported regex documentation can be found here, https://docs.gitlab.com/ee/ci/yaml/#common-if-clauses-for-rules.
#
variables:
  MY_JIRA_KEY: "<YOUR_JIRA_PROJECT_KEY>"    # Custom JIRA key specified by each developer team/repo
  JIRA_API_TOKEN: "<YOUR_TOKEN>"            # JIRA token to auth the callback
  JIRA_SERVER_URL: "<YOUR_SERVER>"          # URL to your JIRA server

stages:
  - build
  - test
  - updatejira

compile:
  stage: build
  script:
    - echo 'building code'

unittest:
  stage: test
  script:
    - echo 'running unit test'

custom-jira-job:
  stage: updatejira
  script:
    - echo "Updating Jira"
    # Example adding a custom formatted comment
    #
    # JIRA API Reference Documentation: https://developer.atlassian.com/cloud/jira/platform/rest/v3/
    #
    # [ STEP 1 - Format custom comment data; inline or local script; perhaps a template engine! ]
    #
    - CUSTOM_CONTENT="<INSERT HERE>"
    #
    # [ STEP 2 - Send a POST to JIRA with custom content]
    #
    # curl --request POST \
    # --url 'https://$JIRA_SERVER_URL/rest/api/3/issue/$MY_JIRA_KEY/comment' \
    # --user 'email@example.com:$JIRA_API_TOKEN' \
    # --header 'Accept: application/json' \
    # --header 'Content-Type: application/json' \
    # --data '{
    # .... skipped ....
    # "body": {
    #   "content": [
    #     "content": [
    #        {
    #           "text": $CUSTOM_CONTENT
    #           "type": "text"
    #        }  
    #     ]  
    #   ]
    # }
    - echo "Jira Updated."
  rules:
    # Requires the custom JIRA key to start at the beginning and include the key flanked by hyphens
    - if: '$MY_JIRA_KEY =~ $CI_COMMIT_BRANCH && $MY_JIRA_KEY =~ /\w{1,6}/ && $CI_COMMIT_BRANCH =~ /^\w{1,6}-\d{1,6}-/'
      when: always
    - when: never
